package com.bergerkiller.bukkit.nolagg;

public class ValueWatcher {
	
	public ValueWatcher(final int valuescale, final int timescale, final int minsize, final int maxsize) {
		this.valuescale = valuescale;
		this.timescale = timescale;
		this.maxsize = maxsize;
		this.minsize = minsize;
	}
	private final int valuescale;
	private final int timescale;
	private final int maxsize;
	private final int minsize;
	private int previousvalue = 0;
	private double rate = 0;
	
	public boolean isMinimized() {
		return this.previousvalue < this.minsize;
	}
	public boolean isMaxed() {
		return this.previousvalue > this.maxsize;
	}
		
	public double getRate() {
		return this.rate;
	}
	
	public int getValue() {
		return this.previousvalue;
	}
	
	public void update(int newvalue) {
		double diff = (newvalue - previousvalue) / (double) valuescale;
		this.rate = (diff + (this.rate * (timescale - 1))) / (double) timescale;
		this.previousvalue = newvalue;
	}

}
